<template>
  <single-pane>
    <ob-table
      :columns="tableColumns"
      :functionalPanel="true"
      :isFunctionalSort="false"
      :isFunctionalGroup="false"
      :showGroup="false"
      :remote-opt="{
        method: getData
      }"
      :show-add-button="false"
      is-fixed-header
      @select="onSelection"
      ref="eventsTable"
    >
      <template v-slot:reasons="{ data }">
        <span class="event-reason" v-for="reason in getActiveReasons(data.item.reasons)" :key="reason">
          {{ reason.title }}
        </span>
      </template>
    </ob-table>
    <ob-modal
      ref="editEventModal"
      size="medium"
      title="Тип события"
      titleSecond="Редактирование"
    >
      <ob-form
        :formModel="formModel"
        :formData="formData"
        @submit="onSubmitEventEdit"
      >
        <div class="form__row">
          <ob-input
            v-model="formData.title"
            label="Наименование"
            readonly
          />
        </div>
        <div class="form__row form__row--small">
          <ob-select
            v-model="formData.entityType"
            label="Сущность"
            readonly
            :items="entityTypes"
          />
        </div>
        <div class='form-reasons'>
          <h4>Причины</h4>
          <div class='form__row form__row--flex' v-for="reason in activeReasons" :key="reason.uuid">
            <ob-input
              ref="reason"
              v-model="reason.title"
              :readonly="!reason.isNew"
            />
            <span class='form-action' @click="onRemoveReason(reason)">
              <i class='icon close'></i>
            </span>
          </div>
        </div>
        <div class='add-reason' @click="onAddReason">
          <i class='icon plus'></i>
          <span>Добавить причину</span>
        </div>
      </ob-form>
    </ob-modal>
    <ob-modal
      ref="deleteWarning"
      title="Удалить причину"
      size="medium"
      isShowControls
      okText="Удалить"
      isError
      @submit="onSubmitDelete"
      @closed="onResetDelete"
    >
      <p>Причина: {{ this.reasonToDelete && this.reasonToDelete.title }}</p>
      <p>Поле удаления причины её нельзя будет использовать в событиях. Везде, где эта причина использовалась ранее, она продолжит отображаться. Вы уверены, что хотите удалить причину?</p>
    </ob-modal>
  </single-pane>
</template>

<script>
import api from '@/api';
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
// import obFuncPanel from 'common-components/src/obComponents/obFuncPanel';
import obTable from 'common-components/src/obComponents/obTable';
import obModal from 'common-components/src/obComponents/obModal';
import obForm from 'common-components/src/obComponents/obForm';
import obInput from 'common-components/src/obComponents/obInput';
import obSelect from 'common-components/src/obComponents/obSelect';
  export default {
    name: 'eventsTypes',

    components: {
      SinglePane,
      obTable,
      obModal,
      obForm,
      obInput,
      obSelect
    },

    data() {
      return {
        tableColumns: [
          {
            title: "Тип событий ",
            key: "title",
            html: (data) => {
              return data.title ? data.title : '—'
            }
          },
          {
            title: "Сущность",
            key: "entityType",
            html: (data) => {
              const entitiesMap = {
                SUBORDER: 'Заказ Перевозчика',
                SPOT_ORDER: 'Спотовый заказ',
                ORDER: 'Заказ Клиента',
                TRIP: 'Рейс'
              }
              return data.entityType ? entitiesMap[data.entityType] : '—'
            }
          },
          {
            title: "Причины",
            key: "reasons",
            slotName: "reasons"
          }
        ],
        formModel: {
          uuid: {
            value: ''
          },
          title: {
            value: ''
          },
          entityType: {
            value: ''
          },
          reasons: {
            value: []
          }
        },
        formData: {
          uuid: '',
          title: '',
          entityType: '',
          reasons: []
        },
        reasonToDelete: null,
        entityTypes: [
          {
            title: 'Заказ Перевозчика',
            uuid: 'SUBORDER'
          },
          {
            title: 'Спотовый заказ',
            uuid: 'SPOT_ORDER'
          },
          {
            title: 'Заказ Клиента',
            uuid: 'ORDER'
          },
          {
            title: 'Рейс',
            uuid: 'TRIP'
          }
        ]
      }
    },

    computed: {
      activeReasons() {
        return this.formData.reasons.filter(item => item.isActive || item.active);
      }
    },

    methods: {
      getActiveReasons(arr) {
        return arr.filter(item => item.isActive || item.active);
      },
      async getData() {
        try {
          const res = await api.dictionaries.events.getEvents();
          const data = res.filter(item => item.isActive || item.active);
          return data;
        } catch (err) {
          console.error(err);
          this.$notification({
            type: "system_notification_error",
            message: `Ошибка при загрузке`,
          });
        }
      },

      onSelection(event) {
        this.formData = {
          uuid: event.uuid,
          title: event.title,
          entityType: event.entityType,
          reasons: event.reasons ? [...event.reasons] : []
        }
        this.$refs.editEventModal.open();
      },

      async onRemoveReason(reason) {
        if (reason.isNew) {
          this.formData.reasons = this.formData.reasons.filter(item => item.uuid !== reason.uuid);
          await this.$nextTick();
          this.focusLastReason()
        } else {
          this.reasonToDelete = reason;
          this.$refs.deleteWarning.open();
        }

      },

      async onSubmitDelete() {
        this.formData.reasons = this.formData.reasons.filter(item => item.uuid !== this.reasonToDelete.uuid);
        this.$refs.deleteWarning.close();
        this.reasonToDelete = null;
        await this.$nextTick();
        this.focusLastReason()
      },

      onResetDelete() {
        this.reasonToDelete = null;
      },

      async onAddReason() {
        const uuid = Date.now(); 
        this.formData.reasons.push({
          title: '',
          uuid: uuid,
          isNew: true,
          isActive: true
        });
        await this.$nextTick();
        this.focusLastReason()
      },

      focusLastReason() {
        const index = this.activeReasons.length - 1;
        const target = this.$refs.reason[index];
        target && target.focus();
      },

      async onSubmitEventEdit() {
        const payload = {
          titles: this.formData.reasons.filter(reason => reason.isActive).map(item => item.title)
        }
        try {
          await api.dictionaries.events.addReasons(this.formData.uuid, payload);
          this.$refs.editEventModal.close();
          this.$refs.eventsTable.loadData();
          this.$notification({
            type: "system_notification_success",
            message: `Тип событий «${this.formData.title}» изменен`,
          });
        } catch (err) {
          console.error(err);
          this.$notification({
            type: "system_notification_error",
            message: `Ошибка при изменении типа событий «${this.formData.title}»`,
          });
        }
      }
    }
  }
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.form__row {
  margin-bottom: 11px;

  &--small {
    width: 280px;
  }

  &--flex {
    display: flex;
    align-items: center;

    & > div {
      flex-grow: 1;
    }
  }
}

.form-reasons {
  margin-top: 19px;

  h4 {
    margin: 0 0 10px;
    @include font-mixin(18px, 20px, 700, $style-black);
  }

  .form-action {
    margin-left: 15px;
    cursor: pointer;
  }
}

.add-reason {
  display: inline-flex;
  margin-top: 9px;
  cursor: pointer;

  span {
    @include font-mixin(14px, 16px, 400, $color-blue-smalt);
    margin-left: 6px;
  }
}

::v-deep {
  .event-reason {
    display: inline-block;
    vertical-align: middle;
    padding: 5px 12px;
    margin-bottom: 5px;
    background-color: #C1EBFF;
    border-radius: 10px;
  
    &:not(:last-child) {
      margin-right: 10px;
    }
  }
}
</style>